.686p
.model flat,c

.CODE

extern LOOP_MAX: dword
extern color_max: dword
extern loop_n_max: dword

; mandel_draw
;double a_min qword[ebp+8]
;double b_min qword[ebp+16]
;double a_max qword[ebp+24]
;double b_max qword[ebp+32]
;int scrx qword[ebp+40]
;int scry qword[ebp+44]
;BYTE* p  qword[ebp+48]
;a_step qword[ebp-16]
;b_step qword[ebp-8]


mandel_draw_fpu proc public
					push ebp
					mov	ebp,esp
					sub	esp,byte ptr 16
					push eax
					push ebx
					push ecx
					push edx
					push esi
					push edi
					mov	edi,dword ptr[color_max]
					mov	ebx,dword ptr[ebp+48]	; p
					fild dword ptr[LOOP_MAX]
					fld qword ptr[ebp+8]		; a_min
					fld qword ptr[ebp+32]		; b_max
					fld qword ptr[ebp+24]		; a_max
					fsub st(0),st(2)
					fild dword ptr[ebp+40]		; scrx
					fdivp st(1),st(0)
					fstp qword ptr[ebp-16]		; a_step
					fld qword ptr[ebp+16]		; b_min
					fsub st(0),st(1)
					fchs
					fild dword ptr[ebp+44]		; 
					fdivp st(1),st(0) 
					fstp qword ptr[ebp-8]
					mov	edx,dword ptr[ebp+44]
loop_y:
					mov	esi,dword ptr[ebp+40]
loop_x:
					mov	ecx,dword ptr[loop_n_max]
					fldz ;
					fldz ; 0=y 1=x 2=b 3=a 4=t
loop2:
					fld st(1) ; 0=x 1=y 2=x 3=b 4=a 5=t
					fmul st(0),st(2) ; 0=x*x 1=y 2=x 3=b 4=a 5=t

					fld st(1) ;  0=y 1=x*x 2=y 3=x 4=b 5=a 6=t
					fmul st(0),st(2) ; 0=y*y 1=x*x 2=y 3=x 4=b 5=a 6=t
					fld  st(1) ;  0=x*x 1=y*y 2=x*x 3=y 4=x 5=b 6=a 7=t
					fsub st(0),st(1)  ; 0=x*x-y*y 1=y*y 2=x*x 3=y 4=x 5=b 6=a 7=t
					fsub st(0),st(6) ;  0=x*x-y*y-a 1=y*y 2=x*x 3=y 4=x 5=b 6=a 7=t

					fxch st(4) ;   0=x 1=y*y 2=x*x 3=y 4=x*x-y*y-a 5=b 6=a 7=t
					fmul st(0),st(3) ; 0=x*y 1=y*y 2=x*x 3=y 4=x*x-y*y-a 5=b 6=a 7=t
					fadd st(0),st(0) ; 0=2*x*y 1=y*y 2=x*x 3=y 4=x*x-y*y-a 5=b 6=a 7=t
					fsub st(0),st(5) ; 0=2*x*y-b 1=y*y 2=x*x 3=y 4=x*x-y*y-a 5=b 6=a 7=t
					fxch st(3) ;  0=y 1=y*y 2=x*x 3=2*x*y-b 4=x*x-y*y-a 5=b 6=a 7=t

					fincstp
					ffree st(7)
								; 0=y*y 1=x*x 2=y=2*x*y-b 3=x=x*x-y*y-a 5=b 5=a 6=t
					fadd st(0),st(1) ; 0=y*y+x*x 1=x*x 2=2*x*y-b 3=x*x-y*y-a 5=b 5=a 6=t
					fcomp st(6) ; 0=x*x 1=2*x*y-b 2=x*x-y*y-a 3=b 4=a 5=t
					fnstsw ax
					fincstp ; 0=y=2*x*y-b 1=x=x*x-y*y-a 3=b 4=a 5=t
					ffree st(7)
					sub ecx,byte ptr 1
					jz	loop_exit2
					test	 ah, 1
					jnz	loop2
loop_exit2:
					fincstp
					ffree st(7)
					fincstp
					ffree st(7)
					mov	eax,ecx
					mov	ecx,dword ptr[loop_n_max]
					sub	ecx,eax
					
					cmp	edi,32768
					jne	short next1
					xor eax,eax
					mov	ax,cx
					shl	al,3		;	                       BBBB B000
					and cx,0ffe0h	;	            0RRR RRGG  GGG0 0000
					shr cx,2		;	            000R RRRR  GGGG G000
					mov ah,cl		;	            GGGG G000  BBBB B000
					and cx,01f00h	;	 0000 0000  000R RRRR  0000 0000
					shl ecx,11		;	 RRRR R000  0000 0000  0000 0000
					add	eax,ecx
					jmp short end1
next1:
					cmp	edi,4096
					jne	next2
					xor eax,eax
					mov	ax,cx
					shl	al,4
					and cl,0f0h
					mov ah,cl
					and cx,00f00h
					shl ecx,8
					add	eax,ecx
					jmp short end1
next2:
					cmp	edi,512
					jne	short next3

					xor eax,eax
					mov	ax,cx
					shl	al,5
					shl	cl,2
					and cl,0e0h
					mov ah,cl
					and cx,001c0h
					shl ecx,10
					add	eax,ecx
					jmp short end1
next3:
					cmp	edi,64
					jne	short end1
	;                      RRGGBB
	; RR000000 GG000000@BB000000
					xor eax,eax
					mov	ax,cx
					mov	ch,cl		; 00RR0000
					shl	al,6		; BB000000
					shl	cl,4		; GG000000
					and cl,0c0h
					mov ah,cl		; GG000000 BB000000
					and cx,00030h
					shl ecx,11
					add	eax,ecx
end1:
					mov	[ebx],eax
					add	ebx,4

					fld	qword ptr[ebp-16]
					faddp st(2),st(0)

					sub	esi,1
					jnz	loop_x

					fld qword ptr[ebp+8]
					fxch st(2)
					fincstp
					ffree st(7)

					fld qword ptr[ebp-8]
					fsubp st(1),st(0)
					sub	edx,1
					jnz	loop_y

					fincstp
					ffree st(7)
					fincstp
					ffree st(7)
					fincstp
					ffree st(7)
					pop edi
					pop esi
					pop edx
					pop ecx
					pop ebx
					pop eax
					add	esp,16
					pop ebp
					ret

mandel_draw_fpu endp


end

