// }fu`vO Version 2.00
// H17.04.17 Version 1.00
// H18.05.08 Version 1.01 }`XbhΉ
// H26.03.30 unicodeAFPU AZuMASMɕύX
// H26.04.06 SSE 4sNZvZ CCAZuőΉ
// H26.04.09 eݒ1̃_CAO{bNX֏W

#include <windows.h>
#include <commctrl.h> 
#include <math.h>
#include <time.h>
#include <stdio.h>
#include <tchar.h>
#include <xmmintrin.h>

#include "resource.h"

#ifndef SM_XVIRTUALSCREEN		// Windows 98ȏŃT|[g
	#define SM_XVIRTUALSCREEN 76
	#define SM_YVIRTUALSCREEN 77
	#define SM_CXVIRTUALSCREEN 78
	#define SM_CYVIRTUALSCREEN 79
#endif

#define ID_STATUS	100		// Xe[^Xo[ID

enum CALC_MODE{ FPU,SSE,CPP };

extern "C" {
	int LOOP_MAX=4;
	int color_max=64;				
	unsigned loop_n_max=64;
	double a_step,b_step;
	CALC_MODE calc_mode=SSE;
}

struct MANDEL_PARA{
	double a_min,b_min,a_max,b_max;
	int scrX,scrY;
	BYTE* pBits;
	int id;
	void put(int n){
		TCHAR buf[256];
		_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("[%i] %.8x %f,%f,%f,%f,%i,%i,%.8x %i\n"),n,(int)this , a_min,b_min,a_max,b_max , scrX,scrY , (int)pBits ,id);
		OutputDebugString(buf);
//		_fputts(buf,fp);
	}
};

DWORD WINAPI mandel_draw_child(LPVOID para);
void mandel_draw_current(double a_min,double b_min,double a_max,double b_max,int scrX,int scrY,BYTE* pBits);  // }`XbhΉ(eXbhI܂ł̊֐͖߂Ȃ)
const int THREAD_MAXS_VALUE=32;
HANDLE draw_h[THREAD_MAXS_VALUE];

int THREAD_MAXS=1;

HWND hStatus;		// Xe[^Xo[̃EBhEnh

	// ݂̕`

double a_min=-1;	
double a_max=1;
double b_min=-1;
double b_max=1;
int select_menu=0;

	// `旚obt@



const int ab_buf_max=5;			// `旚̃TCY
double a_min_a[ab_buf_max];		// TCY
double a_max_a[ab_buf_max];
double b_min_a[ab_buf_max];
double b_max_a[ab_buf_max];
int color_max_a[ab_buf_max];	// F
int loop_n_max_a[ab_buf_max];	// l
int ab_top=0;					// obt@̃gbv
int ab_max=1;					// obt@Ɋi[Ă鐔
int ab_pos=0;					// ݕ\ꂢʒu
TCHAR szClassNme[] = _TEXT("mandel");


int scrX,vscrX,pscrX;	// ̗pXN[TCY,}`j^TCY,vC}fBXvCTCY
int scrY,vscrY,pscrY;


LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);


extern "C" {	// AZuɂ`惋[`
void   mandel_draw_fpu(double a_min,double b_min,double a_max,double b_max,int x,int y,BYTE* p);
}


void mandel_draw_c(double a1,double b1,double a2,double b2,int sx,int sy,BYTE* pBits);
void mandel_draw_sse(double a1,double b1,double a2,double b2,int sx,int sy,BYTE* pBits);


void GetWinRect(HWND hWnd, int *x, int *y);
HWND CreateStatus(HWND hWnd, HINSTANCE hInst);
void status_bar_str(TCHAR*buf,int sz,int mode=0);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPreInst,
                   LPSTR lpszCmdLine, int nCmdShow){
    HWND hWnd;
    MSG lpMsg;
    WNDCLASS myProg;
    if (!hPreInst) {
        myProg.style=CS_HREDRAW | CS_VREDRAW;
        myProg.lpfnWndProc=WndProc;
        myProg.cbClsExtra=0;
        myProg.cbWndExtra=0;
        myProg.hInstance=hInstance;
        myProg.hIcon=NULL;
        myProg.hCursor=LoadCursor(NULL, IDC_ARROW);
        myProg.hbrBackground=(HBRUSH )GetStockObject(WHITE_BRUSH);
        myProg.lpszMenuName=_TEXT("IDM_MENU");
        myProg.lpszClassName=szClassNme;
        if (!RegisterClass(&myProg))
            return FALSE;
    }
    hWnd = CreateWindow(szClassNme,
        _TEXT("Mandelbrot"),
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        NULL,
        NULL,
        hInstance,
        NULL);
    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);
    while (GetMessage(&lpMsg, NULL, 0, 0)){
        TranslateMessage(&lpMsg);
        DispatchMessage(&lpMsg);
    }
    return (lpMsg.wParam);
}

// tN^ݒ_CAO

LRESULT CALLBACK SetDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	TCHAR buf[16];
	TCHAR* color_str[]={ _TEXT("64"),_TEXT("512"),_TEXT("4096"),_TEXT("32768"),0 };
	TCHAR* thread_str[]={ _TEXT("1"),_TEXT("2"),_TEXT("4"),_TEXT("8"),_TEXT("16"),_TEXT("32"),0 };
	int n,i;
    switch (msg) {
        case WM_INITDIALOG:
			i=n=0;
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%i"),color_max);
			while(color_str[n]){
				if(_tcscmp(color_str[n],buf)==0)
					i=n;
				SendMessage( GetDlgItem(hDlg,IDC_COMBOBOX114), CB_ADDSTRING , 0 , (LPARAM)color_str[n++]);
			}
			SendMessage( GetDlgItem(hDlg,IDC_COMBOBOX114), CB_SETCURSEL , (WPARAM)i , (LPARAM)0);

			i=n=0;
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%i"),THREAD_MAXS);
			while(thread_str[n]){
				if(_tcscmp(thread_str[n],buf)==0)
					i=n;
				SendMessage( GetDlgItem(hDlg,IDC_COMBOBOX116), CB_ADDSTRING , 0 , (LPARAM)thread_str[n++]);
			}
			SendMessage( GetDlgItem(hDlg,IDC_COMBOBOX116), CB_SETCURSEL , (WPARAM)i , (LPARAM)0);

			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%i"),scrX);
			SetDlgItemText(hDlg, IDC_EDIT10, buf);
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%i"),scrY);
			SetDlgItemText(hDlg, IDC_EDIT11, buf);
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%f"),a_min);
			SetDlgItemText(hDlg, IDC_EDIT1, (LPCTSTR)buf);
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%f"),a_max);
			SetDlgItemText(hDlg, IDC_EDIT2, (LPCTSTR)buf);
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%f"),b_min);
			SetDlgItemText(hDlg, IDC_EDIT3, (LPCTSTR)buf);
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%f"),b_max);
			SetDlgItemText(hDlg, IDC_EDIT4, (LPCTSTR)buf);
			switch(calc_mode){
			case FPU:
				SendMessage(GetDlgItem(hDlg, IDC_RADIO1), BM_SETCHECK, (WPARAM)BST_CHECKED, 0L);
				break;
			case SSE:
				SendMessage(GetDlgItem(hDlg, IDC_RADIO2), BM_SETCHECK, (WPARAM)BST_CHECKED, 0L);
				break;
			case CPP:
				SendMessage(GetDlgItem(hDlg, IDC_RADIO3), BM_SETCHECK, (WPARAM)BST_CHECKED, 0L);
				break;
			}
            return TRUE;
        case WM_COMMAND:
            switch (LOWORD(wParam)) {
				case IDOK:
					GetDlgItemText(hDlg,IDC_EDIT10,buf, sizeof(buf)/sizeof(TCHAR));
					scrX=_ttoi(buf);
					GetDlgItemText(hDlg,IDC_EDIT11,buf, sizeof(buf)/sizeof(TCHAR));
					scrY=_ttoi(buf);
					GetDlgItemText(hDlg,IDC_EDIT1,buf, sizeof(buf)/sizeof(TCHAR));
					a_min=_tstof(buf);
					GetDlgItemText(hDlg,IDC_EDIT2,buf, sizeof(buf)/sizeof(TCHAR));
					a_max=_tstof(buf);
					GetDlgItemText(hDlg,IDC_EDIT3,buf, sizeof(buf)/sizeof(TCHAR));
					b_min=_tstof(buf);
					GetDlgItemText(hDlg,IDC_EDIT4,buf, sizeof(buf)/sizeof(TCHAR));
					b_max=_tstof(buf);
					n = (int)(DWORD)SendMessage(GetDlgItem(hDlg, IDC_COMBOBOX114), CB_GETCURSEL, 0L, 0L);
					loop_n_max=color_max = _ttoi(color_str[n]);
					n = (int)(DWORD)SendMessage(GetDlgItem(hDlg, IDC_COMBOBOX116), CB_GETCURSEL, 0L, 0L);
					THREAD_MAXS = _ttoi(thread_str[n]);
					if(IsDlgButtonChecked(hDlg, IDC_RADIO1) == BST_CHECKED) {	//	FPU
						calc_mode=FPU;
					}else if(IsDlgButtonChecked(hDlg, IDC_RADIO2) == BST_CHECKED) {	//	SSE
						calc_mode=SSE;
					}else
						calc_mode=CPP;

					EndDialog(hDlg, TRUE);
					return TRUE;
				case IDCANCEL:
					EndDialog(hDlg,FALSE);
					return FALSE;
				case IDC_SDEF:
					SetDlgItemText(hDlg, IDC_EDIT10, _TEXT("800"));
					SetDlgItemText(hDlg, IDC_EDIT11, _TEXT("600"));
					SetDlgItemText(hDlg, IDC_EDIT1, _TEXT("-1.3333"));
					SetDlgItemText(hDlg, IDC_EDIT2, _TEXT("1.3333"));
					SetDlgItemText(hDlg, IDC_EDIT3, _TEXT("-1.0000"));
					SetDlgItemText(hDlg, IDC_EDIT4, _TEXT("1.0000"));
					return TRUE;

				default:
					return FALSE;
			}
			default:
				return FALSE;
	}
	return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	HDC hdc;
	PAINTSTRUCT ps;
	HMENU hMenu; 
	HPEN hPen, hOldPen;
	HBRUSH hBrush;
	static HBITMAP hbit;
	static HBITMAP hbit_clp;
	static HDC memdc_clp=0;
	static HINSTANCE hInst;
	static int wx,wy;				// Xe[^Xo[܂񂾃NCAgTCY
	static int re_draw=1;			// ɍĕ`悷Kvꍇ1
	static int a_on=0;				// obt@Ɋi[ꍇ1
	static int mx=0;				// }EẌʒu
	static int my=0;
	static int mx1=0;
	static int my1=0;
	static int mx2=0;
	static int my2=0;
	static double a1,b1,a2,b2;		// `̈I̍Wێ
	static int select_f=0;			// I𒆂̏ꍇ1
	static int sb_size[] = {60, 120, 180,240,280,320,480,640-1};
	static BITMAPINFOHEADER bmih;
	static BYTE *pBits;
	static HBITMAP hBitmap,HOldBitmap;
	static HDC hdcBMP;
	HANDLE hF;
	DWORD dwResult;
	OPENFILENAME ofn;
	TCHAR szF[MAX_PATH];

	double dx,dy,cx,cy;
	static double a,b;
	int sx,sy;

	hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
	switch (msg) {
	case WM_CREATE:
		color_max_a[0]=color_max;
		loop_n_max_a[0]=loop_n_max;
		ab_max=1;
		OSVERSIONINFO ver;
		ver.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
		GetVersionEx(&ver);
		TCHAR buf[64];
		pscrX=GetSystemMetrics(SM_CXSCREEN);
		pscrY=GetSystemMetrics(SM_CYSCREEN);
		if((ver.dwPlatformId==0 && ver.dwMajorVersion==4 && ver.dwMinorVersion>=10) || (ver.dwPlatformId==2 && ver.dwMajorVersion>=5 && ver.dwMinorVersion>=0)){
			scrX=vscrX=GetSystemMetrics(SM_CXVIRTUALSCREEN);
			scrY=vscrY=GetSystemMetrics(SM_CYVIRTUALSCREEN);
		}else{
			scrX=vscrX=pscrX;
			scrY=vscrY=pscrY;
		}
#if 1
		scrX=800;
		scrY=600;
		a_min=-1.3333;
		a_max=-a_min;
		b_min=-1;
		b_max=-b_min;

#endif

		dy=b_max-b_min;
		dx=dy*scrX/scrY;
		cx=(a_max+a_min)/2;
		a_min=cx-dx/2;
		a_max=cx+dx/2;
		a_min_a[0]=a_min;
		a_max_a[0]=a_max;
		b_min_a[0]=b_min;
		b_max_a[0]=b_max;

		bmih.biSize=sizeof(bmih);
		bmih.biWidth=scrX;
		bmih.biHeight=scrY;
		bmih.biPlanes=1;
		bmih.biBitCount=32;
		bmih.biCompression=BI_RGB;
		bmih.biSizeImage=0;
		bmih.biXPelsPerMeter=0;
		bmih.biYPelsPerMeter=0;
		bmih.biClrUsed=0;
		bmih.biClrImportant=0;
		hBitmap=CreateDIBSection(NULL,(BITMAPINFO*)&bmih,0,(void**)&pBits,NULL,0);
		if(pBits==NULL){
			MessageBox(hWnd,_TEXT("sĂ܂B"),_TEXT("Message"),MB_YESNO | MB_ICONQUESTION);
			SendMessage(hWnd, WM_CLOSE, 0, 0L);
			break;
		}
		hdc=GetDC(hWnd);
		hdcBMP=CreateCompatibleDC(hdc);
		ReleaseDC(hWnd,hdc);
		HOldBitmap=(HBITMAP)SelectObject(hdcBMP,hBitmap);

		CreateStatus(hWnd, hInst);
		SendMessage(hStatus, SB_SETPARTS, (WPARAM)9, (LPARAM)(LPINT)sb_size);
		GetWinRect(hWnd, &wx, &wy);
		ShowWindow(hStatus, SW_SHOW);
		break; 
	case WM_SIZE:
		wx=LOWORD(lParam);
		wy=HIWORD(lParam);
		SendMessage(hStatus, WM_SIZE, wParam, lParam);
		break;
	case WM_MOUSEMOVE:
		mx=LOWORD(lParam);
		my=HIWORD(lParam);
		a=mx/double(wx)*(a_max-a_min)+a_min;
		b=my/double(wy)*(b_max-b_min)+b_min;
		switch(select_menu){
		case IDM_WIN_MOVE:	// ړ
			if(select_f==1){
				_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),TEXT("ړ [%f,%f]"),a,b);
				hdc=GetDC(hWnd);
				hPen = CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
				hOldPen =(HPEN) SelectObject(hdc, hPen);
				SetROP2(hdc,R2_XORPEN);
				SelectObject(hdc, GetStockObject(NULL_BRUSH));
				if(mx1!=-1){
					Rectangle(hdc, mx1-wx/2, my1-wy/2, mx1+wx/2, my1+wy/2);
					MoveToEx(hdc,mx1-wx/2,my1-wy/2,NULL);
					LineTo(hdc,mx1+wx/2, my1+wy/2);
					MoveToEx(hdc,mx1-wx/2,my1+wy/2,NULL);
					LineTo(hdc,mx1+wx/2, my1-wy/2);
				}
				Rectangle(hdc, mx-wx/2, my-wy/2, mx+wx/2, my+wy/2);
				MoveToEx(hdc,mx-wx/2,my-wy/2,NULL);
				LineTo(hdc,mx+wx/2, my+wy/2);
				MoveToEx(hdc,mx-wx/2,my+wy/2,NULL);
				LineTo(hdc,mx+wx/2, my-wy/2);
				SelectObject(hdc, hOldPen);
				DeleteObject(hPen);
				ReleaseDC(hWnd,hdc);
				mx1=mx;
				my1=my;
			}else
				_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("ړ [%f,%f]"),a,b);
			SendMessage(hStatus, SB_SETTEXT, 6 | 0, (WPARAM)(LPSTR)buf);
			break;
		case IDM_WIN_ZOOM:	// Y[̈w蒆
			if(select_f==1){
				a=mx/double(wx)*(a_max-a_min)+a_min;
				dx=a-a1;
				dy=dx*double(wy)/double(wx);
				b=b1+dy;
				dx=mx-mx1;
				dy=dx*double(wy)/double(wx);
				my=my1+int(dy);
				_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("Y[ [%f,%f]-[%f,%f]"),a1,b1,a2=a,b2=b);
				hdc=GetDC(hWnd);
				HPEN hPen, hOldPen;
				hPen = CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
				hOldPen =(HPEN) SelectObject(hdc, hPen);
				SetROP2(hdc,R2_XORPEN);
				SelectObject(hdc, GetStockObject(NULL_BRUSH));
				if(mx2!=-1)
					Rectangle(hdc, mx1, my1, mx2, my2);
				Rectangle(hdc, mx1, my1, mx, my);
				SelectObject(hdc, hOldPen);
				DeleteObject(hPen);
				ReleaseDC(hWnd,hdc);
				mx2=mx;
				my2=my;
			}else
				_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("Y[ [%f,%f]"),a,b);
			SendMessage(hStatus, SB_SETTEXT, 6 | 0, (WPARAM)(LPSTR)buf);
			break;
		default:
			status_bar_str(buf,sizeof(buf)/sizeof(TCHAR),select_menu);
			SendMessage(hStatus, SB_SETTEXT, 6 | 0, (WPARAM)(LPSTR)buf);
		}
		break;
	case WM_LBUTTONDOWN:
		switch(select_menu){
		case IDM_WIN_ZOOM:	// @Y[̈捶w芮
			a1=a;
			b1=b;
			mx1=mx;
			my1=my;
			mx2=my2=-1;
			select_f=1;
			break;
		case IDM_WIN_MOVE:	//   ړ\Jn
			mx1=my1=-1;
			select_f=1;
			break;
		default:
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("down"));
			SendMessage(hStatus, SB_SETTEXT, 6 | 0, (WPARAM)buf);
		}
		break;
	case WM_LBUTTONUP:
		switch(select_menu){
		case IDM_WIN_ZOOM:		// Y[̈Ew芮
			select_f=0;
			if(a1==a2 || b1==b2)
				break;
			re_draw=1;
			a_min=min(a1,a2);
			a_max=max(a1,a2);
			b_min=min(b1,b2);
			b_max=max(b1,b2);
			a_on=1;
			InvalidateRect(hWnd,NULL,1);
			break;
		case IDM_WIN_MOVE:		// ړS_w芮
			hdc=GetDC(hWnd);
			hPen = CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
			hOldPen =(HPEN) SelectObject(hdc, hPen);
			SetROP2(hdc,R2_XORPEN);
			SelectObject(hdc, GetStockObject(NULL_BRUSH));
			Rectangle(hdc, mx1-scrX/2, my1-scrY/2, mx1+scrX/2, my1+scrY/2);
			MoveToEx(hdc,mx1-scrX/2,my1-scrY/2,NULL);
			LineTo(hdc,mx1+scrX/2, my1+scrY/2);
			MoveToEx(hdc,mx1-scrX/2,my1+scrY/2,NULL);
			LineTo(hdc,mx1+scrX/2, my1-scrY/2);
			SelectObject(hdc, hOldPen);
			DeleteObject(hPen);
			ReleaseDC(hWnd,hdc);
			dx=a_max-a_min;
			dy=b_max-b_min;
			a=mx1/double(wx)*dx+a_min;
			b=my1/double(wy)*dy+b_min;
			a_min=a-dx/2;
			a_max=a+dx/2;
			b_min=b-dy/2;
			b_max=b+dy/2;
			re_draw=1;
			mx1=my1=-1;
			select_f=0;
			a_on=1;
			InvalidateRect(hWnd,NULL,1);
			break;
		default:
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("up"));
			SendMessage(hStatus, SB_SETTEXT, 6 | 0, (WPARAM)(LPSTR)buf);
		}
		break;
	case WM_COMMAND:
		hMenu=GetMenu(hWnd);
		switch (LOWORD(wParam)) {
		case IDM_ALLSET:
			sx=scrX;
			sy=scrY;
			if(DialogBox(hInst, _TEXT("ALLSET_DLG"), hWnd, (DLGPROC)SetDlgProc)){
				re_draw=1;
				scrX=(scrX+3) & 0xfffffffc;
				DeleteObject(hBitmap);
				bmih.biSize=sizeof(bmih);
				bmih.biWidth=scrX;
				bmih.biHeight=scrY;
				bmih.biPlanes=1;
				bmih.biBitCount=32;
				bmih.biCompression=BI_RGB;
				bmih.biSizeImage=0;
				bmih.biXPelsPerMeter=0;
				bmih.biYPelsPerMeter=0;
				bmih.biClrUsed=0;
				bmih.biClrImportant=0;
				hBitmap=CreateDIBSection(NULL,(BITMAPINFO*)&bmih,0,(void**)&pBits,NULL,0);
				if(pBits==NULL){
					MessageBox(hWnd,_TEXT("sĂ܂B"),_TEXT("Message"),MB_YESNO | MB_ICONQUESTION);
					SendMessage(hWnd, WM_CLOSE, 0, 0L);
				}
				hdc=GetDC(hWnd);
				ReleaseDC(hWnd,hdcBMP);
				hdcBMP=CreateCompatibleDC(hdc);
				ReleaseDC(hWnd,hdc);
				SelectObject(hdcBMP,hBitmap);
				if(double(sx)/double(sy) <=double(scrX)/double(scrY)){ // c
					dy=b_max-b_min;
					cx=(a_max+a_min)/2;
					dx=dy*double(scrX)/double(scrY);
					a_min=cx-dx/2;
					a_max=cx+dx/2;
				}else{
					dx=a_max-a_min;
					cy=(b_max+b_min)/2;
					dy=dx*double(scrY)/double(scrX);
					b_min=cy-dy/2;
					b_max=cy+dy/2;
				}
				InvalidateRect(hWnd,NULL,1);
			}
			break;
		case IDM_SAVE2:
			BITMAPFILEHEADER bmfh;
			bmfh.bfType=0x4d42;
			bmfh.bfSize=sizeof(bmfh)+sizeof(bmih)+scrX*scrY*4;
			bmfh.bfReserved1=0;
			bmfh.bfReserved2=0;
			bmfh.bfOffBits=sizeof(bmfh)+sizeof(bmih);

			TCHAR title_name[MAX_PATH];
			memset(&ofn, 0, sizeof(OPENFILENAME));
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = hWnd;
			ofn.lpstrFilter = _TEXT("Windows DIB (*.bmp)\0*.bmp\0\0");
			ofn.nFilterIndex = 1;
			ofn.lpstrFile = szF;	//	tpX
			szF[0]=_T('\0');
			ofn.lpstrFileTitle=title_name;
			ofn.nMaxFile = MAX_PATH;	// tpXő啶
			ofn.nMaxFileTitle=MAX_PATH;
			ofn.lpstrTitle=_TEXT("Otĕۑ");
			ofn.lpstrDefExt=_TEXT(".bmp");
			ofn.Flags =  OFN_OVERWRITEPROMPT;

			if (GetSaveFileName((LPOPENFILENAME)&ofn)==0)
				break;

			hF = CreateFile(szF, GENERIC_WRITE,	0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
			if (hF == INVALID_HANDLE_VALUE) {
				MessageBox(hWnd, _TEXT("ۑł܂łB"),_TEXT( "Error"), MB_OK);
				break;
			}
			WriteFile(hF, &bmfh, sizeof(bmfh), &dwResult, NULL);
			WriteFile(hF, &bmih, sizeof(bmih), &dwResult, NULL);
			WriteFile(hF, pBits, scrX*scrY*4, &dwResult, NULL);
			CloseHandle(hF);

			break;
			
		case IDM_EXIT:
			SendMessage(hWnd, WM_CLOSE, 0, 0L);
			break;
		case IDM_BACK:
			int n;
			if(ab_top-ab_pos>=ab_max-1)
				break;
			if(ab_top<ab_pos && ab_top-ab_pos+ab_buf_max>=ab_max-1)
				break;
			if(ab_pos==0){
				if(ab_max>1)
					n=ab_buf_max-1;
				else
					break;
			}else{
				if(ab_max>1)
					n=ab_pos-1;
				else
					break;
			}
			a_min=a_min_a[n];
			a_max=a_max_a[n];
			b_min=b_min_a[n];
			b_max=b_max_a[n];
			color_max=color_max_a[n];
			loop_n_max=loop_n_max_a[n];
			ab_pos=n;
			re_draw=1;
			InvalidateRect(hWnd,NULL,1);
			break;
		case IDM_FORU:
			if(ab_top==ab_pos)	//ȏi߂Ȃ
				break;
			if(ab_max==0)
				break;
			if(ab_pos==ab_max-1) //obt@ŏʃAhX̏ꍇ
				n=0;
			else
				n=ab_pos+1;
			a_min=a_min_a[n];
			a_max=a_max_a[n];
			b_min=b_min_a[n];
			b_max=b_max_a[n];
			color_max=color_max_a[n];
			loop_n_max=loop_n_max_a[n];
			ab_pos=n;
			re_draw=1;
			InvalidateRect(hWnd,NULL,1);
		break;
		case IDM_ZOOM_OUT:
			dx=a_max-a_min;
			dy=b_max-b_min;
			a_min-=dx;
			a_max+=dx;
			b_min-=dy;
			b_max+=dy;
			re_draw=1;
			a_on=1;
			InvalidateRect(hWnd,NULL,1);
			select_menu=LOWORD(wParam);
			SendMessage(hStatus, SB_SETTEXT, 6 | 0, (WPARAM)_TEXT("Y[AEg"));
			break;
		case IDM_WIN_ZOOM:
			select_menu=LOWORD(wParam);
		    SendMessage(hStatus, SB_SETTEXT, 6 | 0, (WPARAM)_TEXT("Y["));
			break;
		case IDM_WIN_MOVE:
			select_menu=LOWORD(wParam);
		    SendMessage(hStatus, SB_SETTEXT, 6 | 0, (WPARAM)_TEXT("ړ"));
			break;
		default:
			select_menu=0;
			break;
		}
		break;
	case WM_TIMER:
		InvalidateRect(hWnd,NULL,1);
		break;
	case WM_DESTROY:
		DeleteObject(hBitmap);
		PostQuitMessage(0);
		break;
	case WM_CLOSE:
		DestroyWindow(hStatus);
		DestroyWindow(hWnd);
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		hPen = CreatePen(PS_SOLID, 1, RGB(0, 255, 0));
		hOldPen =(HPEN) SelectObject(hdc, hPen);
		hBrush = (HBRUSH)GetStockObject(NULL_BRUSH);
		if(re_draw==1){
			re_draw=0;
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%f"),a_min);
			SendMessage(hStatus, SB_SETTEXT, 0 | 0, (WPARAM)buf);
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%f"),b_min);
			SendMessage(hStatus, SB_SETTEXT, 1 | 0, (WPARAM)buf);
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%f"),a_max);
			SendMessage(hStatus, SB_SETTEXT, 2 | 0, (WPARAM)buf);
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%f"),b_max);
			SendMessage(hStatus, SB_SETTEXT, 3 | 0, (WPARAM)buf);
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%i"),color_max);
			SendMessage(hStatus, SB_SETTEXT, 4 | 0, (WPARAM)buf);
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%i"),loop_n_max);
			SendMessage(hStatus, SB_SETTEXT, 5 | 0, (WPARAM)buf);
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("%iXbhŌvZ"),THREAD_MAXS);
			SendMessage(hStatus, SB_SETTEXT, 6 | 0, (WPARAM)buf);
			SendMessage(hStatus, SB_SETTEXT, 7 | 0, (WPARAM)_TEXT(""));
			clock_t s=clock();
			mandel_draw_current(a_min,b_min,a_max,b_max,scrX,scrY,pBits);
			clock_t e=clock();
			if(a_on==1){
				if(ab_top==ab_buf_max-1)
					ab_top=0;
				else
					++ab_top;
				ab_pos=ab_top;
				if(ab_max<ab_buf_max)
					++ab_max;
				a_min_a[ab_top]=a_min;
				a_max_a[ab_top]=a_max;
				b_min_a[ab_top]=b_min;
				b_max_a[ab_top]=b_max;
				color_max_a[ab_top]=color_max;
				loop_n_max_a[ab_top]=loop_n_max;
				a_on=0;
			}
			double t=double(e-s)/double(CLOCKS_PER_SEC);
			_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("vZ %fb"),t);
			SendMessage(hStatus, SB_SETTEXT, 7 | 0, (WPARAM)(LPSTR)buf);
		}
		hMenu=GetMenu(hWnd);
		if(ab_top-ab_pos>=ab_max-1)
			EnableMenuItem(hMenu,IDM_BACK,	MF_BYCOMMAND | MF_GRAYED);
		else if(ab_top<ab_pos && ab_top-ab_pos+ab_buf_max>=ab_max-1)
			EnableMenuItem(hMenu,IDM_BACK,	MF_BYCOMMAND | MF_GRAYED);
		else
			EnableMenuItem(hMenu,IDM_BACK,	MF_BYCOMMAND | MF_ENABLED);
		if(ab_top==ab_pos)
			EnableMenuItem(hMenu,IDM_FORU,	MF_BYCOMMAND | MF_GRAYED);
		else if(ab_max==0)
			EnableMenuItem(hMenu,IDM_FORU,	MF_BYCOMMAND | MF_GRAYED);
		else
			EnableMenuItem(hMenu,IDM_FORU,	MF_BYCOMMAND | MF_ENABLED);
		GetWinRect(hStatus, &sx, &sy);
		StretchBlt(hdc,0,0,wx,wy-sy,hdcBMP,0,0,scrX,scrY,SRCCOPY);
		SelectObject(hdc, hOldPen);
		DeleteObject(hPen);
        EndPaint(hStatus, &ps);
		status_bar_str(buf,sizeof(buf)/sizeof(TCHAR),select_menu);
		SendMessage(hStatus, SB_SETTEXT, 6 | 0, (WPARAM)(LPSTR)buf);
        break;
    default:
        return(DefWindowProc(hWnd, msg, wParam, lParam));
    }
    return (0);
}

void GetWinRect(HWND hWnd, int *x, int *y){
    RECT rc;
    GetClientRect(hWnd, &rc);
    *x = rc.right - rc.left;
    *y = rc.bottom - rc.top;
    return;
}

HWND CreateStatus(HWND hWnd, HINSTANCE hInst){
    hStatus = CreateWindowEx(
        0,
        STATUSCLASSNAME,
        NULL,
        WS_CHILD | SBARS_SIZEGRIP | CCS_BOTTOM | WS_VISIBLE,
        0,
        0,
        0,
        0,
        hWnd,
        (HMENU)ID_STATUS,
        hInst,
        NULL);
    return hStatus;
}

void status_bar_str(TCHAR*buf,int sz,int mode){
	switch(mode){
	case IDM_WIN_MOVE:
		_tcscpy_s(buf,sz,_TEXT("ړ ")); break;
	case IDM_WIN_ZOOM:
		_tcscpy_s(buf,sz,_TEXT("Y[ ")); break;
	default:
		_tcscpy_s(buf,sz,_TEXT("")); break;
	}
}

void mandel_draw_current(double a_min,double b_min,double a_max,double b_max,int scrX,int scrY,BYTE* pBits){  // }`XbhΉ(eXbhI܂ł̊֐͖߂Ȃ)
	MANDEL_PARA para[THREAD_MAXS_VALUE];
	DWORD id[THREAD_MAXS_VALUE];
	double b=b_max;
	double p_step=scrX*4*scrY/THREAD_MAXS;
	double b_pich=(b_max-b_min)/double(scrY);
	double b_step=int(scrY/THREAD_MAXS)*b_pich;
	double p=scrX*4*scrY-p_step;
	TCHAR buf[16];
	int b_sum=0;
	int n;
	unsigned ssx=scrY/THREAD_MAXS;
	for(n=0;n<THREAD_MAXS;n++){
		para[n].a_min=a_min;
		para[n].b_min=(n+1==THREAD_MAXS) ? b_min : b-b_step;
		para[n].a_max=a_max;
		para[n].b_max=b;
		para[n].scrX=scrX;
		para[n].scrY=(n+1==THREAD_MAXS) ? scrY-b_sum : (scrY/THREAD_MAXS);
		para[n].pBits=pBits+n*scrX*4*ssx;
		para[n].id=n;
		_stprintf_s(buf,sizeof(buf)/sizeof(TCHAR),_TEXT("akuma%i"),n);
		draw_h[n]=CreateEvent(NULL,0,0,buf);	// Cxgnh̐ݒ
		CreateThread(NULL,0,&mandel_draw_child,&para[n],0,&id[n]);
#if _DEBUG
		para[n].put(n);
#endif
		b-=b_step;
		p-=p_step;
		b_sum+=scrY/THREAD_MAXS;
	}
	for(n=0;n<THREAD_MAXS;n++){
		WaitForSingleObject(draw_h[n],INFINITE);	// `悪I܂őҋ@B
		CloseHandle(draw_h[n]);
	}
}


DWORD WINAPI mandel_draw_child(LPVOID para){	// currentɕNXbh
	MANDEL_PARA* p=(MANDEL_PARA*)para;
	switch(calc_mode){
	case FPU:
		mandel_draw_fpu(p->a_min,p->b_min,p->a_max,p->b_max,p->scrX,p->scrY,p->pBits);
		break;
	case SSE:
		mandel_draw_sse(p->a_min,p->b_min,p->a_max,p->b_max,p->scrX,p->scrY,p->pBits);
		break;
	case CPP:
		mandel_draw_c(p->a_min,p->b_min,p->a_max,p->b_max,p->scrX,p->scrY,p->pBits);
		break;
	}
	SetEvent(draw_h[p->id]);	// `̏Im点
	return 0;	
}



//	SSEgp4sNZ𓯎tN^vZs(Px_)

void mandel_draw_sse(double a1,double b1,double a2,double b2,int sx,int sy,BYTE* pBits){
	float amax=(float)a2;
	float amin=(float)a1;
	int scrx=sx;
	float bmax=(float)b2;
	float bmin=(float)b1;
	int scry=sy;
	BYTE* p=pBits;
	const float lim=4.0;
	const unsigned B_MASK=0x0000c0;
	const unsigned B8_MASK=0x0000e0;
	const unsigned B32_MASK=0x0000f8;
	const unsigned CONST1=1;

	__m128 an;
	__m128 astep;
	__m128 bn;
	__m128 bstep;


	_asm{
		mov		eax,p
		mov		edi,scry
		mov		esi,scrx
		movss	xmm1,amax
		movss	xmm0,amin
		subss	xmm1,xmm0
		cvtsi2ss xmm2,esi

		divss	xmm1,xmm2	;	astep

		shufps	xmm0,xmm0,0x34 ; 3<-0 2<-2 1<-1 0<-0

		addss	xmm0,xmm1
		shufps	xmm0,xmm0,0xc4 ; 3<-3 2<-0 1<-1 0<-0
		
		addss	xmm0,xmm1
		shufps	xmm0,xmm0,0xe0 ; 3<-3 2<-2 1<-0 0<-0

		addss	xmm0,xmm1

		shufps	xmm0,xmm0,0x1b ; 3<-0 2<-1 1<-2 0<-3
		shufps	xmm1,xmm1,0	;	

		movaps	an,xmm0
		addps	xmm1,xmm1
		addps	xmm1,xmm1
		movaps	astep,xmm1


		movss	xmm3,bmin
		movss	xmm2,bmax
		subss	xmm3,xmm2
		cvtsi2ss xmm4,edi

		divss	xmm3,xmm4	;	bstep

		shufps	xmm2,xmm2,0x34 ; 3<-0 2<-2 1<-1 0<-0

		addss	xmm2,xmm3
		shufps	xmm2,xmm2,0xc4 ; 3<-3 2<-0 1<-1 0<-0
		
		addss	xmm2,xmm3
		shufps	xmm2,xmm2,0xe0 ; 3<-3 2<-2 1<-0 0<-0

		addss	xmm2,xmm3

		shufps	xmm2,xmm2,0x1b ; 3<-0 2<-1 1<-2 0<-3
		shufps	xmm3,xmm3,0	;	

		movaps	bn,xmm2
		movaps	bstep,xmm3

y_loop:
		mov		esi,scrx
		shr		esi,1
		shr		esi,1
		movups	xmm0,an
x_loop:
		movss	xmm7,lim
		shufps	xmm7,xmm7,0

		xorps	xmm4,xmm4		; x=0
		xorps	xmm5,xmm5		; y=0
		xorpd	xmm1,xmm1		; count
		mov		ecx,loop_n_max
LOOP_L1:
		movaps	xmm6,xmm4
		mulps	xmm6,xmm5	; x*y
		addps	xmm6,xmm6	; 2*x*y
		subps	xmm6,xmm2	; zy=2*x*y-b

		mulps	xmm4,xmm4		; x2=x*x
		mulps	xmm5,xmm5		; y2=y*y
		movaps	xmm3,xmm4
		subps	xmm4,xmm5	; x2-y2
		subps	xmm4,xmm0	; x=zx=x2-y2-a
		addps	xmm3,xmm5	; x2+y2
		movaps	xmm5,xmm6	; y=zy
		cmpltps	xmm3,xmm7	; x2+y2<4 ^ 1 U 0
		pmovmskb edx,xmm3	;	eoCg̍ŏʃrbgedxɃRs[
		test	edx,edx		;	4sNZƂlim𒴂ꍇ[v𔲂
		jz	LOOP_L1_EXIT

		movd	xmm6,CONST1
		pshufd	xmm6,xmm6,0
		pand	xmm3,xmm6
		paddd	xmm1,xmm3	; O̔r߂^̎JEg
		loop	LOOP_L1
LOOP_L1_EXIT:
	// 64
		cmp		color_max,64
		jne		next_color1
;	RRGGBB->RR0000 GG0000 BB0000 64F32bitJ[Ƀ}bsO

		movdqa	xmm5,xmm1	;	0000 00RR GGBB
		pslld	xmm1,6		;   RRGG BB00 0000
		movdqa	xmm4,xmm1
		movd	xmm7,B_MASK
		shufps	xmm7,xmm7,0
		pand	xmm1,xmm7	; 
							;   0000 RRGG BB00 0000
		pslld	xmm4,6		;RR GGBB 0000 0000 0000
		movdqa	xmm5,xmm4
		pslldq	xmm7,1
		pand	xmm4,xmm7	; 
		por		xmm1,xmm4
							; 0000 00RR GGBB 0000 0000 0000
		pslld	xmm5,6		; RR00 0000 0000 0000 0000 0000
		pslldq	xmm7,1
		pand	xmm5,xmm7	; 
		por		xmm1,xmm5
		jmp		end_color
	// 512
;	R RRGG GBBB->RRR000 GGG000 BBB000 512F32bitJ[Ƀ}bsO
next_color1:
		cmp		color_max,512
		jne		next_color2
		movdqa	xmm5,xmm1	;	000R RRGG GBBB
		pslld	xmm1,5		;   RGGG BBB0 0000
		movdqa	xmm4,xmm1
		movd	xmm7,B8_MASK
		shufps	xmm7,xmm7,0
		pand	xmm1,xmm7	; 
							;   00RR RGGG BBB0 0000
		pslld	xmm4,5		;RR GGG0 0000 0000 0000
		movdqa	xmm5,xmm4
		pslldq	xmm7,1
		pand	xmm4,xmm7	; 
		por		xmm1,xmm4
							; 0000 00RR GGBB 0000 0000 0000
		pslld	xmm5,5		; RR00 0000 0000 0000 0000 0000
		pslldq	xmm7,1
		pand	xmm5,xmm7	; 
		por		xmm1,xmm5
		jmp		end_color
	// 4096
;	RRRR GGGG BBBB->RRRR00 GGGG00 BBBB00 4096F32bitJ[Ƀ}bsO
next_color2:
		cmp		color_max,4096
		jne		next_color3

		movdqa	xmm5,xmm1	;	RRRR GGGG BBBB
		pslld	xmm1,4		;   GGGG BBBB 0000
		movdqa	xmm4,xmm1
		movd	xmm7,B8_MASK
		shufps	xmm7,xmm7,0
		pand	xmm1,xmm7	; 
							;   RRRR GGGG BBBB 0000
		pslld	xmm4,4		;RR GGGG 0000 0000 0000
		movdqa	xmm5,xmm4
		pslldq	xmm7,1
		pand	xmm4,xmm7	; 
		por		xmm1,xmm4
							; 0000 RRRR GGGG 0000 0000 0000
		pslld	xmm5,4		; RRRR 0000 0000 0000 0000 0000
		pslldq	xmm7,1
		pand	xmm5,xmm7	; 
		por		xmm1,xmm5
		jmp		end_color

		//	32768
;	RR RRRG GGGGB BBBB->RRRR R000 GGGG G000 BBBB B000 32768F32bitJ[Ƀ}bsO
next_color3:

		movdqa	xmm5,xmm1	;	  00RR RRRB BBBB
		pslld	xmm1,3		;   R RRRR BBBB B000
		movdqa	xmm4,xmm1
		movd	xmm7,B32_MASK
		shufps	xmm7,xmm7,0
		pand	xmm1,xmm7	; 
							; 000G GGGG 0000 0000
		pslld	xmm4,3		; GGGG G000 0000 0000
		movdqa	xmm5,xmm4
		pslldq	xmm7,1
		pand	xmm4,xmm7	; 
		por		xmm1,xmm4
							; 000R RRRR 0000 0000 0000 0000
		pslld	xmm5,3		; RRRR R000 0000 0000 0000 0000
		pslldq	xmm7,1
		pand	xmm5,xmm7	; 
		por		xmm1,xmm5
end_color:
		movups	[eax],xmm1
		add		eax,16
		movaps	xmm1,astep
		addps	xmm0,xmm1	;an+=astep
		
		dec		esi
		jnz		x_loop

		movups	xmm3,bstep
		addps	xmm2,xmm3
		dec		edi
		jnz		y_loop
	}

}

void mandel_draw_c(double a1,double b1,double a2,double b2,int sx,int sy,BYTE* pBits){
	int x0=sx;
	int y0=sy;
	double a_min=a1;
	double a_max=a2;
	double b_min=b1;
	double b_max=b2;
	double a_step=(a_max-a_min)/x0;
	double b_step=(b_max-b_min)/y0;
	BYTE* top=pBits;
	double b=b_max;
	while(y0--){
		double a=a_min;
		x0=sx;
		while(x0--){
			double x=0;
			double y=0;
			unsigned int c=0;
			for(c=0 ; c < ::loop_n_max ; c++){
				double x2=x*x;
				double y2=y*y;
				double zx=x2-y2-a;
				double zy=2*x*y-b;
				x=zx;
				y=zy;
				if(x2+y2>= ::LOOP_MAX)
					break;
			}
			unsigned cr,cg,cb;
			switch(color_max){
			case 32768:	//	0rrr rrgg gggb bbbb
				cr=(c<<3) & 0xf8;
				cg=(c>>2) & 0xf8;
				cb=(c>>6) & 0xf8;
				c=RGB(cr,cg,cb);
				break;
			case 4096:	//	 rrrr gggg bbbb
				cr=(c<<4) & 0xf0;
				cg=c & 0xf0;
				cb=(c>>4) & 0xf0;
				c=RGB(cr,cg,cb);
				break;
			case 512:	//	r rrgg gbbb
				cr=(c<<5) & 0xe0;
				cg=(c<<2) & 0xe0;
				cb=(c>>1) & 0xe0;
				c=RGB(cr,cg,cb);
				break;
			case 64:	//	rr ggbb
				cr=(c<<2) & 0xc0;
				cg=(c<<4) & 0xc0;
				cb=(c<<6) & 0xc0;
				c=RGB(cb,cg,cr);
				break;
			}
			INT32* i32=(INT32*)pBits;
			*i32=c;
			pBits+=sizeof(INT32)/sizeof(pBits[0]);
			a+=a_step;
		}
		b-=b_step;
	}
}
